; Ŀ
;  Procedure:  Error()                                                     
;  Purpose: This procedure is an example of an error procedure.  When an   
;  error occurs, Paradox checks to see if the system variable errorproc    
;  has been assigned a value.  If it has, Paradox attempts to execute a    
;  with the same name as that stored in the variable errorproc.            
;                                                                          
;    This script is part of a sample application described in the          
;    October 1993 issue of Paradox Information.  This script was written   
;    by Cary Jensen of Data Works of Houston.                              
;                                                                          
;    This script is for demonstration purposes only.  No representation    
;    is made concerning the appropriateness of this script for any other   
;    purpose.  If you use this script you agree to hold its author and     
;    Data Works of Houston free from any claim arising out of the use or   
;    misuse of this script.                                                
; ͵
;                              Cary Jensen                                 
;                          Data Works of Houston                           
;                             CIS 76307,1533                               
;                             (713) 359-3311                               
; ͵
; 
PROC Error()
PRIVATE ErrorProc, a  ;Making ErrorProc private prevents 
                      ;an infinite loop in case the error
                      ;procedure itself causes an error.
;Display a message to the user indicating that
;an error has occured and what action to take.

;If the variable Development is True, enter the debugger.  This is
;a tool for the developer.  Before delivering the application, set the
;variable Development to False.
IF Development
  THEN
    RETURN 2
ENDIF
CLEAR
@ 10,1 ?? "An error has occurred."
@ 12,1 ?? "Please call the application administrator."
@ 14,1 ?? "Press any key to return to Paradox."
MESSAGE ERRORMESSAGE()
IF DRIVESPACE(SUBSTR(DIRECTORY(),1,1)) < 4096
;Tests to make sure that there is at least 4K of space
;available on the current drive.  
  THEN
    ;Not enough disk space to write to ERROR.ERR.
    ;Instead, release all variables and QUIT
    ;to Paradox.
    a=GETCHAR()
    RESET    ;Terminate all non-Main mode activity.
    QUIT     ;Use EXIT instead of QUIT to exit to DOS.
ENDIF
;There is enough disk space for the error history file.
;Create a dynamic array with the error information.
ERRORINFO To ErrorArray
;Append this error to the error history.
PRINT FILE "ERROR.ERR" "*******************************\n"
PRINT FILE "ERROR.ERR" "The time =     ",TIME(),"\n"
PRINT FILE "ERROR.ERR" "The date =     ",TODAY(),"\n"
PRINT FILE "ERROR.ERR" "System mode  = ",SYSMODE(),"\n"
FOREACH Element IN ErrorArray
 PRINT FILE "ERROR.ERR" Element,"=",ErrorArray[Element],"\n"
ENDFOREACH
a=GETCHAR()
RESET  ;Terminate all non-Main mode activity.
QUIT  ;To return to DOS rather than Paradox, use EXIT here.
ENDPROC  ;---Error()
WRITELIB "Paradox" Error
RELEASE PROCS Error
