; Ŀ
;  Procedure:  GenLib                                                      
;  Purpose  :  Re-generate the application library based on the procedures 
;  defined in the scripts listed in the table called Script.DB.            
;                                                                          
;    This script is part of a sample application described in the          
;    October 1993 issue of Paradox Information.  This script was written   
;    by Cary Jensen of Data Works of Houston.                              
;                                                                          
;    This script is for demonstration purposes only.  No representation    
;    is made concerning the appropriateness of this script for any other   
;    purpose.  If you use this script you agree to hold its author and     
;    Data Works of Houston free from any claim arising out of the use or   
;    misuse of this script.                                                
; ͵
;                              Cary Jensen                                 
;                          Data Works of Houston                           
;                             CIS 76307,1533                               
;                             (713) 359-3311                               
; ͵
; 

PROC GENLIB()
Private ScriptDir, TheCol
SWITCH
  CASE NOT ISTABLE("Scripts"):
    RETURN "Scripts table not found."
  CASE NOT SYSMODE() = "Main":
    RETURN "You must run Genlib from the Main mode."    
ENDSWITCH
LibName = "Paradox"
Message "Creating "+libname
ScriptDir = DIRECTORY()
HighColor = SYSCOLOR(3)
NormalColor = SYSCOLOR(9)
;Create the library.
IF NRECORDS("Scripts")>45
  THEN
    CREATELIB Libname SIZE NRECORDS("Scripts")+10
  ELSE
    CREATELIB libname
ENDIF
EDIT "Scripts"
MOVETO [Script name]
;Determine the field width for highlighting the scripts as they are proc'd.
FIELDVIEW HOME SYNCCURSOR TheCol = COL() ENTER DO_IT!
CURSOR OFF
;Play each script in the Scripts table.
SCAN
   ECHO NORMAL
   ECHO OFF
   SYNCCURSOR
   CANVAS OFF
   PAINTCANVAS ATTRIBUTE HighColor ROW(),TheCol,ROW(),TheCol+8
   CANVAS ON
   MESSAGE "Adding ",Scriptdir+[Script name]
      Play Scriptdir+[Script name]
   PAINTCANVAS ATTRIBUTE NormalColor ROW(),10,ROW(),17
ENDSCAN
CLEARIMAGE
CURSOR NORMAL
RETURN Libname + " has been re-generated."
ENDPROC ;--- GenLib()
GenLib()
IF NOT ISBLANK(Retval)
  THEN
    RETURN Retval
ENDIF
