; Ŀ
;  Script:  MortCalc                                                       
;  Purpose:  MortCalc is a mortage calculation program.  Enter the purchase
;  price, downpayment percentage, annual interest rate, and number of years
;  of the loan, and MortCalc will calculate your downpayment amount and    
;  monthly mortage payments.                                               
;                                                                          
;    This script is part of a sample application described in the          
;    October 1993 issue of Paradox Information.  This script was written   
;    by Cary Jensen of Data Works of Houston.                              
;                                                                          
;    This script is for demonstration purposes only.  No representation    
;    is made concerning the appropriateness of this script for any other   
;    purpose.  If you use this script you agree to hold its author and     
;    Data Works of Houston free from any claim arising out of the use or   
;    misuse of this script.                                                
; ͵
;                              Cary Jensen                                 
;                          Data Works of Houston                           
;                             CIS 76307,1533                               
;                             (713) 359-3311                               
; ͵
; 
PROC MortCalc()
PRIVATE a, Price, DownPayment, Rate, Years, MonthlyPayment
a=0     ;Initialize the variable a for use in the WHILE loop.

PROC Continue()     ;Since the test of Retval after ACCEPT
   IF NOT RETVAL    ;is the same for each of the four following ACCEPT
      THEN QUIT     ;statements, this test is made into a procedure
   ENDIF            ;and executed by calling the procedure name.  This saves
ENDPROC             ;programming time and space within the program

WHILE NOT a=27
   CLEAR
   @ 0,  0
   ?? FORMAT("W80,Ac","M O R T A G E    C A L C U L A T I O N    P R O G R A M")
   @ 4, 9 ?? "(100000 = One hundred thousand dollars)"
   @ 3, 9 ?? "Please enter the total purchase price : "
   STYLE REVERSE
   ACCEPT "N" MIN 1 REQUIRED TO Price
   STYLE
   Continue()
   @ 3, 49 CLEAR EOL ?? FORMAT("W11.2,EC$",Price)

   @ 7, 9 ?? "(For example, 10 equals 10 percent)"
   @ 6, 9 ?? "Please enter the downpayment percent  : "
   STYLE REVERSE
   ACCEPT "N" PICTURE "#[#][.*#]]" REQUIRED TO PercentDown
   STYLE
   Continue()
   @ 6, 49 CLEAR EOL ?? FORMAT("W7.3",PercentDown)," %"

   @10, 9 ?? "(Annual rate.  9.5 equals 9.5 percent)"
   @ 9, 9 ?? "Please enter the interest rate        : "
   STYLE REVERSE
   ACCEPT "N" PICTURE "#[#][.*#]]" REQUIRED TO Rate
   STYLE
   Continue()
   @ 9, 49 CLEAR EOL ?? FORMAT("W7.3",Rate)," %"

   @13, 9 ?? "(For a 20 year loan, enter 20)"
   @12, 9 ?? "Please enter the years of the loan    : "
   STYLE REVERSE
   ACCEPT "N" MIN 1 PICTURE "#*[#][.*#]" REQUIRED TO Years
   STYLE
   Continue()
   @12, 49 CLEAR EOL ?? FORMAT("W6.2",Years)," years"

   PercentDown = PercentDown/100     ;These two lines are divided by 100 to
   Rate = Rate/12/100                ;convert the percentages to decimal values.
   DownPayment = Price * (PercentDown)
   LoanAmount = Price - DownPayment
   Monthlypayment = PMT(LoanAmount,Rate,12*Years)

   @ 17, 23 ?? "Amount of loan     : ", FORMAT("W11.2,EC$",LoanAmount)
   @ 19, 23 ?? "Down payment       : ", FORMAT("W11.2,EC$",DownPayment)
   @ 21, 23 ?? "Monthly mortage    : ", FORMAT("W11.2,EC$",MonthlyPayment)
   STYLE REVERSE
   @ 24, 0 ?? FORMAT("W80,AC","<Press any key to continue, or Esc to exit>")
   STYLE
   CURSOR OFF
   a=GETCHAR()
   CURSOR NORMAL
ENDWHILE
ENDPROC
MortCalc()    ;This procedure call executes the above defined procedure.
